Index: branches/libIGCM_MPI_OpenMP/libIGCM_config/libIGCM_config.ksh
===================================================================
--- branches/libIGCM_MPI_OpenMP/libIGCM_config/libIGCM_config.ksh	(revision 570)
+++ branches/libIGCM_MPI_OpenMP/libIGCM_config/libIGCM_config.ksh	(revision 571)
@@ -387,327 +431,372 @@
 function IGCM_config_PeriodStart
 {
-    IGCM_debug_PushStack "IGCM_config_PeriodStart"
-
-    echo
-    IGCM_debug_Print 1 "IGCM_config_PeriodStart"
-    echo
-
-    if ( ${FirstInitialize} ) ; then
-        #================================================#
-        #         Initialize date/period information     #
-        #================================================#
-
-	IGCM_date_GetYearMonth $DateBegin year month
-	year_m1=$(( year - 1 ))
-	year_p1=$(( year + 1 ))	
-	IGCM_config_Analyse_PeriodLength
-
-	eval PeriodDateBegin=${DateBegin} > /dev/null 2>&1
-	PeriodDateEnd=$( IGCM_date_AddDaysToGregorianDate ${DateBegin} $(( ${PeriodLengthInDays} - 1 )) )
-	eval CumulPeriod=1 > /dev/null 2>&1
-
-        #=================================================#
-        #              Write updated run.card             #
-        #=================================================#
-
-	#Correct run.card Configuration for this period
-	IGCM_card_WriteOption ${SUBMIT_DIR}/run.card Configuration PeriodDateBegin ${PeriodDateBegin}
-	IGCM_card_WriteOption ${SUBMIT_DIR}/run.card Configuration PeriodDateEnd ${PeriodDateEnd}
-	IGCM_card_WriteOption ${SUBMIT_DIR}/run.card Configuration CumulPeriod ${CumulPeriod}
-	if [ X$( grep "SubmitPath" ${SUBMIT_DIR}/run.card ) != X ] ; then
-	    IGCM_card_WriteOption ${SUBMIT_DIR}/run.card Configuration SubmitPath ${SUBMIT_DIR}
-	fi
-
-	IGCM_card_WriteOption ${SUBMIT_DIR}/run.card Configuration PeriodState "Running"
- 
+  IGCM_debug_PushStack "IGCM_config_PeriodStart"
+
+  echo
+  IGCM_debug_Print 1 "IGCM_config_PeriodStart"
+  echo
+
+  if ( ${FirstInitialize} ) ; then
+    #================================================#
+    #         Initialize date/period information     #
+    #================================================#
+
+    IGCM_date_GetYearMonthDay $DateBegin year month day
+    IGCM_config_Analyse_PeriodLength
+
+    eval PeriodDateBegin=${DateBegin} > /dev/null 2>&1
+    PeriodDateEnd=$( IGCM_date_AddDaysToGregorianDate ${DateBegin} $(( ${PeriodLengthInDays} - 1 )) )
+    eval CumulPeriod=1 > /dev/null 2>&1
+
+    #=================================================#
+    #              Write updated run.card             #
+    #=================================================#
+
+    #Correct run.card Configuration for this period
+    IGCM_card_WriteOption ${SUBMIT_DIR}/run.card Configuration PeriodDateBegin ${PeriodDateBegin}
+    IGCM_card_WriteOption ${SUBMIT_DIR}/run.card Configuration PeriodDateEnd ${PeriodDateEnd}
+    IGCM_card_WriteOption ${SUBMIT_DIR}/run.card Configuration CumulPeriod ${CumulPeriod}
+    if [ X$( grep "SubmitPath" ${SUBMIT_DIR}/run.card ) != X ] ; then
+      IGCM_card_WriteOption ${SUBMIT_DIR}/run.card Configuration SubmitPath ${SUBMIT_DIR}
+    fi
+
+    IGCM_card_WriteOption ${SUBMIT_DIR}/run.card Configuration PeriodState "Running"
+    
+  else
+    #================================================#
+    #         The file run.card allready exist       #
+    #================================================#
+
+    #Test state of run in run.card
+    IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/run.card Configuration PeriodState
+    if ( [ ${run_Configuration_PeriodState} != "Running" ] && [ ${run_Configuration_PeriodState} != "OnQueue" ] && [ ${run_Configuration_PeriodState} != "Continue" ] ) ; then
+      echo 
+      IGCM_debug_Print 1 "!! Error in run.card with PeriodState : " ${run_Configuration_PeriodState} "!!"
+      IGCM_debug_Print 1 "Try running ${libIGCM}/clean_month.job to fix this"
+      echo
+      IGCM_debug_Exit
+      IGCM_debug_Verif_Exit
+    fi
+
+    #===================================#
+    #        Read updated run.card      #
+    #===================================#
+
+    IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/run.card Configuration OldPrefix
+    IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/run.card Configuration PeriodDateBegin
+    IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/run.card Configuration PeriodDateEnd
+    IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/run.card Configuration CumulPeriod
+
+    PeriodDateBegin=$( IGCM_date_ConvertFormatToGregorian ${run_Configuration_PeriodDateBegin} )
+    PeriodDateEnd=$( IGCM_date_ConvertFormatToGregorian ${run_Configuration_PeriodDateEnd} )
+    eval CumulPeriod="${run_Configuration_CumulPeriod}" > /dev/null 2>&1
+
+    LastPeriodDateEnd=$( echo ${run_Configuration_OldPrefix} | sed -e "s/${config_UserChoices_JobName}_//" )
+
+    typeset LastDate
+    set +A LastDate -- $( echo ${LastPeriodDateEnd} | sed -e "s/\([0-9]\{${dY}\}\)\([0-9]\{2\}\)\([0-9]\{2\}\)/\1 \2 \3/" )
+    LastYearDateEnd=${LastDate[0]}
+    LastMonthDateEnd=${LastDate[1]}
+    LastDayDateEnd=${LastDate[2]}
+
+    if [ ${Period} = 1 ]; then
+      # save last Job output
+      typeset LastPeriod iLastPeriod Last_Script_Output_Name
+      (( LastPeriod=CumulPeriod-PeriodNb ))
+      iLastPeriod=$( printf "%06d" ${LastPeriod} )
+      Last_Script_Output_Name="${Script_Output_Prefix}_${config_UserChoices_JobName}.${iLastPeriod}"
+      Last_run_card="run.card.${iLastPeriod}"
+      #eval ls -l ${SUBMIT_DIR}/${Last_Script_Output_Name}
+      #eval IGCM_sys_Put_Out ${SUBMIT_DIR}/${Last_Script_Output_Name} ${R_BUF_KSH}/${Last_Script_Output_Name} > /dev/null 2>&1
+      IGCM_debug_Print 2 "Try to save previous ksh job output"
+      IGCM_sys_Cd ${SUBMIT_DIR}/
+      IGCM_sys_PutBuffer_Out ${Last_Script_Output_Name} ${R_BUF_KSH}/${Last_Script_Output_Name}.$$ rw
+
+      IGCM_card_CheckConflict run.card
+      IGCM_sys_PutBuffer_Out ${SUBMIT_DIR}/run.card ${R_BUF_KSH}/${Last_run_card}.$$ rw
+
+      IGCM_sys_Cd ${RUN_DIR}
     else
-        #================================================#
-        #         The file run.card allready exist       #
-        #================================================#
-
-	#Test state of run in run.card
-	IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/run.card Configuration PeriodState
-	if ( [ ${run_Configuration_PeriodState} != "Running" ] && [ ${run_Configuration_PeriodState} != "OnQueue" ] && [ ${run_Configuration_PeriodState} != "Continue" ] ) ; then
-	    echo 
-	    IGCM_debug_Print 1 "!! Error in run.card with PeriodState : " ${run_Configuration_PeriodState} "!!"
-	    IGCM_debug_Print 1 "Try running ${libIGCM}/clean_month.job to fix this"
-	    echo
-	    IGCM_debug_Exit
-	    IGCM_debug_Verif_Exit
-	fi
-
-        #===================================#
-        #        Read updated run.card      #
-        #===================================#
-
-	IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/run.card Configuration OldPrefix
-	IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/run.card Configuration PeriodDateBegin
-	IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/run.card Configuration PeriodDateEnd
-	IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/run.card Configuration CumulPeriod
-
-	PeriodDateBegin=$( IGCM_date_ConvertFormatToGregorian ${run_Configuration_PeriodDateBegin} )
-	PeriodDateEnd=$( IGCM_date_ConvertFormatToGregorian ${run_Configuration_PeriodDateEnd} )
-	eval CumulPeriod="${run_Configuration_CumulPeriod}" > /dev/null 2>&1
-
-	LastPeriodDateEnd=$( echo ${run_Configuration_OldPrefix} | sed -e "s/${config_UserChoices_JobName}_//" )
-
-	typeset LastDate
-	set +A LastDate -- $( echo ${LastPeriodDateEnd} | sed -e "s/\([0-9]\{${dY}\}\)\([0-9]\{2\}\)\([0-9]\{2\}\)/\1 \2 \3/" )
-	LastYearDateEnd=${LastDate[0]}
-	LastMonthDateEnd=${LastDate[1]}
-	LastDayDateEnd=${LastDate[2]}
-
-	if [ ${Period} = 1 ]; then
-           # save last Job output
-	    typeset LastPeriod iLastPeriod Last_Script_Output_Name
-	    (( LastPeriod=CumulPeriod-PeriodNb ))
-	    iLastPeriod=$( printf "%06d" ${LastPeriod} )
-	    Last_Script_Output_Name="${Script_Output_Prefix}_${config_UserChoices_JobName}.${iLastPeriod}"
-	    Last_run_card="run.card.${iLastPeriod}"
- 	    #eval ls -l ${SUBMIT_DIR}/${Last_Script_Output_Name}
- 	    #eval IGCM_sys_Put_Out ${SUBMIT_DIR}/${Last_Script_Output_Name} ${R_OUT_KSH}/${Last_Script_Output_Name} > /dev/null 2>&1
-	    IGCM_debug_Print 2 "Try to save previous ksh job output"
-	    IGCM_sys_Cd ${SUBMIT_DIR}/
-	    IGCM_sys_Put_Out ${Last_Script_Output_Name} ${R_OUT_KSH}/${Last_Script_Output_Name}.$$ rw
-
-	    IGCM_card_CheckConflict run.card
-	    IGCM_sys_Put_Out ${SUBMIT_DIR}/run.card ${R_OUT_KSH}/${Last_run_card}.$$ rw
-
-	    IGCM_sys_Cd ${RUN_DIR}
-	else
-	    unset FileToBeDeleted
-	fi
-
-	IGCM_date_GetYearMonth $PeriodDateBegin year month
-	year_m1=$(( year - 1 ))
-	year_p1=$(( year + 1 ))	
-	IGCM_config_Analyse_PeriodLength
-
-	IGCM_card_WriteOption ${SUBMIT_DIR}/run.card Configuration PeriodState "Running"
-
-    fi    
-    OldPrefix=${config_UserChoices_JobName}_${PeriodDateEnd}
-  
-    #===================================================================#
-    # Prepare variables available for ${COMP}.card and ${COMP}.driver   #
-    #             But available to any son functions                    #
-    #===================================================================#
-
-    # Period Length In Days between DateBegin and DateCurrent (at end of period == PeriodDateEnd !)
-    (( SimulationLengthInDays = $( IGCM_date_DaysBetweenGregorianDate ${PeriodDateEnd} ${DateBegin} ) + 1 ))
-
-    # Debug Print :
-    IGCM_debug_Print 1 "IGCM_config_PeriodStart : Before Execution"
-    IGCM_debug_Print 1 "Year of simulation      : ${year}"
-    IGCM_debug_Print 1 "Month of simulation     : ${month}"
-    IGCM_debug_Print 1 "PeriodLengthInDays      : ${PeriodLengthInDays}"
-    IGCM_debug_Print 1 "PeriodDateBegin         : ${PeriodDateBegin}"
-    IGCM_debug_Print 1 "PeriodDateEnd           : ${PeriodDateEnd}"
-    IGCM_debug_Print 1 "SimulationLengthInDays  : ${SimulationLengthInDays}"
-    IGCM_debug_Print 1 "ExperienceLengthInDays  : ${ExperienceLengthInDays}"
-
-    #================================================================#
-    #         Prepare variables available for comp_finalyze          #
-    #================================================================#
-
-    # Period for save files
-    eval DatesPeriod=${PeriodDateBegin}_${PeriodDateEnd} > /dev/null 2>&1
-
-    # Prefix for save files of this period
-    eval PREFIX=${config_UserChoices_JobName}_${DatesPeriod}  > /dev/null 2>&1
-
-    # List of files that will be deleted in RUN_DIR after run
-    [ -f stack ] && FileToBeDeleted[0]="stack"
-
-    # Test if the same run as already been saved :
-    if [ X${JobType} = XRUN ] ; then
-	if [ ${DRYRUN} -le 0 ] ; then
-	    if ( IGCM_sys_TestFileArchive ${R_OUT_KSH}/${PREFIX}_${Exe_Output} ) ; then
-		IGCM_debug_Exit "IGCM_config_PeriodStart" "You are currently RErunning an old job."
-		IGCM_debug_Print 1 "Because of readonly permissions, you can't RErun a job when saved files"
-		IGCM_debug_Print 1 " are still in the ARCHIVE directory. You must deleted those files, or "
-		IGCM_debug_Print 1 " the whole ${R_SAVE} tree. See clean_month.job in ${libIGCM} directory."
-		IGCM_debug_Print 1 " This exit has been initiated because at least ${R_OUT_KSH}/${PREFIX}_${Exe_Output} exists."
-		IGCM_debug_Verif_Exit
-	    fi
-	fi
+      unset FileToBeDeleted
+    fi
+
+    IGCM_date_GetYearMonthDay $PeriodDateBegin year month day
+    IGCM_config_Analyse_PeriodLength
+
+    IGCM_card_WriteOption ${SUBMIT_DIR}/run.card Configuration PeriodState "Running"
+
+  fi    
+  OldPrefix=${config_UserChoices_JobName}_${PeriodDateEnd}
+
+  # BEGIN: SHOULD GO IN A FUNCTION FROM libIGCM_date.ksh
+  # Compute year_m1 and year_p1 (year minus 1Y and year plus 1Y)
+  year_m1=$(( year - 1 ))
+  year_p1=$(( year + 1 ))	
+  # Compute month_m1 (month minus 1M)
+  # Compute yyyymm_m1 (yyyymm minus 1M)
+  month_m1=$(( month - 1 ))
+  if [ ${month_m1} = 0 ]; then
+    month_m1=12
+    yyyymm_m1=${year_m1}12
+  elif [ ${month_m1} -le 9 ]; then
+    month_m1=0${month_m1}
+    yyyymm_m1=${year}${month_m1}
+  else
+    yyyymm_m1=${year}${month_m1}
+  fi
+  # Compute month_p1 (month plus 1M)
+  # Compute yyyymm_p1 (yyyymm plus 1M)
+  month_p1=$(( month + 1 ))
+  if [ ${month_p1} = 13 ]; then
+    month_p1=01
+    yyyymm_p1=${year_p1}01
+  elif [ ${month_p1} -le 9 ]; then
+    month_p1=0${month_p1}
+    yyyymm_p1=${year}${month_p1}
+  else
+    yyyymm_p1=${year}${month_p1}
+  fi
+  #IGCM_debug_Print 1 "jg 1 month_m1 = ${month_m1} month_p1 = ${month_p1} "
+  #IGCM_debug_Print 1 "jg 1 calculate yyyymm_m1 = ${yyyymm_m1} "
+  #IGCM_debug_Print 1 "jg 1 calculate yyyymm_p1 = ${yyyymm_p1} "
+
+  # END: SHOULD GO IN A FUNCTION FROM libIGCM_date.ksh
+
+  #===================================================================#
+  # Prepare variables available for ${COMP}.card and ${COMP}.driver   #
+  #             But available to any son functions                    #
+  #===================================================================#
+
+  # Period Length In Days between DateBegin and DateCurrent (at end of period == PeriodDateEnd !)
+  (( SimulationLengthInDays = $( IGCM_date_DaysBetweenGregorianDate ${PeriodDateEnd} ${DateBegin} ) + 1 ))
+
+  # Debug Print :
+  IGCM_debug_Print 1 "IGCM_config_PeriodStart : Before Execution"
+  IGCM_debug_Print 1 "Year of simulation      : ${year}"
+  IGCM_debug_Print 1 "Month of simulation     : ${month}"
+  IGCM_debug_Print 1 "PeriodLengthInDays      : ${PeriodLengthInDays}"
+  IGCM_debug_Print 1 "PeriodDateBegin         : ${PeriodDateBegin}"
+  IGCM_debug_Print 1 "PeriodDateEnd           : ${PeriodDateEnd}"
+  IGCM_debug_Print 1 "SimulationLengthInDays  : ${SimulationLengthInDays}"
+  IGCM_debug_Print 1 "ExperienceLengthInDays  : ${ExperienceLengthInDays}"
+
+  #================================================================#
+  #         Prepare variables available for comp_finalyze          #
+  #================================================================#
+
+  # Period for save files
+  eval DatesPeriod=${PeriodDateBegin}_${PeriodDateEnd} > /dev/null 2>&1
+
+  # Prefix for save files of this period
+  eval PREFIX=${config_UserChoices_JobName}_${DatesPeriod}  > /dev/null 2>&1
+
+  # List of files that will be deleted in RUN_DIR after run
+  [ -f stack ] && FileToBeDeleted[0]="stack"
+
+  # Test if the same run as already been saved :
+  if [ X${JobType} = XRUN ] ; then
+    if [ ${DRYRUN} -le 0 ] ; then
+      if ( IGCM_sys_TestFileBuffer ${R_BUF_KSH}/${PREFIX}_${Exe_Output} ) ; then
+	IGCM_debug_Exit "IGCM_config_PeriodStart" "You are currently RErunning an old job."
+	IGCM_debug_Print 1 "Because of readonly permissions, you can't RErun a job when saved files"
+	IGCM_debug_Print 1 " are still in the ARCHIVE directory. You must deleted those files, or "
+	IGCM_debug_Print 1 " the whole ${R_SAVE} tree. See clean_month.job in ${libIGCM} directory."
+	IGCM_debug_Print 1 " This exit has been initiated because at least ${R_BUF_KSH}/${PREFIX}_${Exe_Output} exists."
+	IGCM_debug_Verif_Exit
+      fi
+    fi
+  else
+    if ( IGCM_sys_TestFileBuffer ${R_BUF_KSH}/${PREFIX}_${Exe_Output} ) ; then
+      IGCM_debug_Print 1 "IGCM_config_PeriodStart" "RErun an old job. Allowed in DEBUG or DEV mode."
+    fi
+  fi
+
+  typeset ExeNameIn ExeNameFirst CompNameFirst
+  typeset comp i
+  typeset tempvar tempvarMPI tempvarNOD NbElts j NbExec
+
+  (( PROCESSUS_NUMBER = 0 ))
+  (( i=0 ))
+  (( NbExec=0 ))
+
+  OK_PARA_MPI=false
+  OK_PARA_OMP=false
+  OK_PARA_NOD=false
+  OK_PARA_MPMD=false
+
+  for comp in ${config_ListOfComponents[*]} ; do
+
+    IGCM_debug_Print 1 ${comp}
+
+    eval ExeNameIn=\${config_Executable_${comp}[0]}
+
+    # NO order in config.card for parallelized values ! 
+    # just use suffix : MPI , OMP and NOD (for number of NODes.)
+
+    # NOD is the number of NODes allocated
+    eval ${comp}_PROC_NOD=0
+
+    # MPI is the number of MPI processus per nodes
+    eval ${comp}_PROC_MPI=0
+
+    # OMP is the number of OpenMP threads per MPI processus
+    eval ${comp}_PROC_OMP=0
+	
+    # Only if we really have an executable for the component :
+    if [ X${ExeNameIn} != X\"\" ] ; then
+
+      # Keep the first executable found and the first CompName
+      ExeNameFirst=${ExeNameIn}
+      CompNameFirst=${comp}
+
+      # Are we a second executable?
+      (( NbExec = NbExec + 1 ))
+
+      # set 1 MPI task, 1 OpenMP thread and 1 node as default
+      eval ${comp}_PROC_MPI=1
+      eval ${comp}_PROC_OMP=1
+      eval ${comp}_PROC_NOD=1
+
+      eval NbElts=\${#config_Executable_${comp}[@]}
+
+      if [ ${NbElts} -ge 2 ] ; then
+        (( j = 2 ))
+
+        while [ $j -lt ${NbElts} ] ; do 
+          eval tempvar=\${config_Executable_${comp}[${j}]}
+
+          if [ X${tempvar} == X ] ; then
+            echo "Error reading MPI/OMP parameters !!!" 
+            echo "Check your config.card." 
+            exit 1
+          fi
+
+          eval IGCM_debug_Print 2 ${tempvar}
+
+          case ${tempvar} in
+            *[mM][pP][iI]*)
+               # Read MPI parameter for composante
+               eval ${comp}_PROC_MPI=$( echo ${tempvar} | tr '[a-z]' '[A-Z]' | sed -e "s/MPI//" )
+               OK_PARA_MPI=true;;
+            *[oO][mM][pP]*)
+               # Read OMP parameter for composante
+               eval ${comp}_PROC_OMP=$( echo ${tempvar} | tr '[a-z]' '[A-Z]' | sed -e "s/OMP//" )
+               OK_PARA_OMP=true;;
+            *[nN][oO][dD]*)
+               # Read NOD (NumBer of Nodes) parameter for composante
+               eval ${comp}_PROC_NOD=$( echo ${tempvar} | tr '[a-z]' '[A-Z]' | sed -e "s/NOD//" )
+               OK_PARA_NOD=true
+               OK_PARA_MPI=true;;
+          esac
+
+          (( j = j + 1 ))
+        done
+
+      fi
+
+      eval tempvarMPI=\${${comp}_PROC_MPI}
+      eval tempvarNOD=\${${comp}_PROC_NOD}
+      eval tempvarOMP=\${${comp}_PROC_OMP}
+
+      (( PROCESSUS_NUMBER = PROCESSUS_NUMBER + tempvarMPI * tempvarNOD * tempvarOMP ))
+
+    fi
+
+    (( i=i+1 ))
+  done
+
+  # set MPMD mode if more than 2 executable names.
+  [ ${NbExec} -ge 2 ] && OK_PARA_MPMD=true
+
+  # Verification of BATCH_NUM_PROC_TOT total number of processors set in job header.
+  if [ X${BATCH_NUM_PROC_TOT} != X ] ; then
+    # BATCH_NUM_PROC_TOT is set
+    if ( ${OK_PARA_MPI} ) ; then
+      IGCM_debug_Print 1 "MPI/OMP/NOD found into config.card and BATCH_NUM_PROC_TOT = ${BATCH_NUM_PROC_TOT} "
     else
-	if ( IGCM_sys_TestFileArchive ${R_OUT_KSH}/${PREFIX}_${Exe_Output} ) ; then
-	    IGCM_debug_Print 1 "IGCM_config_PeriodStart" "RErun an old job. Allowed in DEBUG or DEV mode."
-	fi
-    fi
-
-    typeset ExeNameIn ExeNameFirst CompNameFirst
-    typeset comp i
-    typeset tempvar tempvarMPI tempvarNOD NbElts j NbExec
-
-    (( PROCESSUS_NUMBER = 0 ))
-    (( i=0 ))
-    (( NbExec=0 ))
-
-    OK_PARA_MPI=false
-    OK_PARA_OMP=false
-    OK_PARA_NOD=false
-    OK_PARA_MPMD=false
-
-    for comp in ${config_ListOfComponents[*]} ; do
-
-	IGCM_debug_Print 1 ${comp}
-
-	eval ExeNameIn=\${config_Executable_${comp}[0]}
-
-	# NO order in config.card for parallelized values ! 
-	# just use suffix : MPI , OMP and NOD (for number of NODes.)
-
-	# NOD is the number of NODes allocated
-	eval ${comp}_PROC_NOD=0
-
-	# MPI is the number of MPI processus per nodes
-	eval ${comp}_PROC_MPI=0
-
-	# OMP is the number of OpenMP threads per MPI processus
-	eval ${comp}_PROC_OMP=0
-	
-	# Only if we really have an executable for the component :
-	if [ X${ExeNameIn} != X\"\" ] ; then
-
-	    # Keep the first executable found and the first CompName
-	    ExeNameFirst=${ExeNameIn}
-	    CompNameFirst=${comp}
-
-	    # Are we a second executable?
-	    (( NbExec = NbExec + 1 ))
-
-	    # set 1 MPI task, 1 OpenMP thread and 1 node as default
-	    eval ${comp}_PROC_MPI=1
-	    eval ${comp}_PROC_OMP=1
-	    eval ${comp}_PROC_NOD=1
-
-	    eval NbElts=\${#config_Executable_${comp}[@]}
-
-	    if [ ${NbElts} -ge 2 ] ; then
-		(( j = 2 ))
-
-		while [ $j -lt ${NbElts} ] ; do 
-		    eval tempvar=\${config_Executable_${comp}[${j}]}
-
-		    echo 
-#MM BUG impossible ?!
-		    if [ X${tempvar} == X ] ; then
-			echo "Error reading MPI/OMP parameters !!!" 
-			echo "Check your config.card." 
-		    # MM : A  enlever :
-			exit 1
-                        #break
-		    fi
-
-		    eval IGCM_debug_Print 2 ${tempvar}
-
-		    case ${tempvar} in
-			*[mM][pP][iI]*)
-                            # Read MPI parameter for composante
-			    eval ${comp}_PROC_MPI=$( echo ${tempvar} | tr '[a-z]' '[A-Z]' | sed -e "s/MPI//" )
-			    OK_PARA_MPI=true;;
-			*[oO][mM][pP]*)
-                            # Read OMP parameter for composante
-			    eval ${comp}_PROC_OMP=$( echo ${tempvar} | tr '[a-z]' '[A-Z]' | sed -e "s/OMP//" )
-			    OK_PARA_OMP=true;;
-			*[nN][oO][dD]*)
-                            # Read NOD (NumBer of Nodes) parameter for composante
-			    eval ${comp}_PROC_NOD=$( echo ${tempvar} | tr '[a-z]' '[A-Z]' | sed -e "s/NOD//" )
-			    OK_PARA_NOD=true
-			    OK_PARA_MPI=true;;
-		    esac
-
-		    (( j = j + 1 ))
-		done
-
- 	    fi
-
-	    eval tempvarMPI=\${${comp}_PROC_MPI}
-	    eval tempvarNOD=\${${comp}_PROC_NOD}
-	    eval tempvarOMP=\${${comp}_PROC_OMP}
-
-	    (( PROCESSUS_NUMBER = PROCESSUS_NUMBER + tempvarMPI * tempvarNOD * tempvarOMP ))
-
-	fi
-
-	(( i=i+1 ))
-    done
-
-    # set MPMD mode if more than 2 executable names.
-    [ ${NbExec} -ge 2 ] && OK_PARA_MPMD=true
-
-    # Verification of BATCH_NUM_PROC_TOT total number of processors set in job header.
-    if [ X${BATCH_NUM_PROC_TOT} != X ] ; then
-	# BATCH_NUM_PROC_TOT is set
-	if ( ${OK_PARA_MPI} ) ; then
-	    IGCM_debug_Print 1 "MPI/OMP/NOD fund into config.card and BATCH_NUM_PROC_TOT = ${BATCH_NUM_PROC_TOT} "
-	else
-	    # with previous method.
-	    if [ ${BATCH_NUM_PROC_TOT} -gt 1 ] ; then
-		# with more than 1 proc
-		if ( ${OK_PARA_MPMD} ) ; then
-		     # with MPMD ie CPL/oasis method
-		     echo "We will use default number of MPI tasks for this machine : "
-		     echo "${DEFAULT_NUM_PROC_OCE} for OCE; "
-		     echo "${DEFAULT_NUM_PROC_CPL} for CPL; "
-		     echo "${DEFAULT_NUM_PROC_ATM} for ATM; "
-		     echo "${DEFAULT_NUM_PROC_TOTAL} for the total number of processors; "
-		     OK_PARA_MPI=true
-		     CPL_PROC_MPI=${DEFAULT_NUM_PROC_CPL}
-		     OCE_PROC_MPI=${DEFAULT_NUM_PROC_OCE}
-		     ATM_PROC_MPI=${DEFAULT_NUM_PROC_ATM}
-		     NUM_PROC_CPL=${DEFAULT_NUM_PROC_CPL} # for backward compatibility
-		     NUM_PROC_OCE=${DEFAULT_NUM_PROC_OCE} # for backward compatibility
-		     NUM_PROC_ATM=${DEFAULT_NUM_PROC_ATM} # for backward compatibility
-		     PROCESSUS_NUMBER=${DEFAULT_NUM_PROC_TOTAL}
-		else
-		     # with have only one executable
-		     echo "We will use ${BATCH_NUM_PROC_TOT} MPI tasks for ${CompNameFirst} : ${config_Executable_Name} "
-		     OK_PARA_MPI=true
-		     eval ${CompNameFirst}_PROC_MPI=${BATCH_NUM_PROC_TOT}
-		     PROCESSUS_NUMBER=${BATCH_NUM_PROC_TOT}
-		fi
-	    else 
-		PROCESSUS_NUMBER=1
-	    fi
-	fi
-	# Verification with PBS parameter
-        if [ ${BATCH_NUM_PROC_TOT} -ne ${PROCESSUS_NUMBER} ] ; then
-            echo "Warning with parallelization parameters !"
-            echo "Job header variable BATCH_NUM_PROC_TOT = ${BATCH_NUM_PROC_TOT} "
-            echo "is the total number of _processors_ reserved."
-            echo "It is not equal to the sum of _processus_  = ${PROCESSUS_NUMBER}."
-	    echo "We stop now."
-	    exit 1
+      # with previous method.
+      if [ ${BATCH_NUM_PROC_TOT} -gt 1 ] ; then
+        # with more than 1 proc
+        if ( ${OK_PARA_MPMD} ) ; then
+          # with MPMD ie CPL/oasis method
+          echo "We will use default number of MPI tasks for this machine : "
+          echo "${DEFAULT_NUM_PROC_OCE} for OCE; "
+          echo "${DEFAULT_NUM_PROC_CPL} for CPL; "
+          echo "${DEFAULT_NUM_PROC_ATM} for ATM; "
+          echo "${DEFAULT_NUM_PROC_TOTAL} for the total number of processors; "
+          OK_PARA_MPI=true
+          CPL_PROC_MPI=${DEFAULT_NUM_PROC_CPL}
+          OCE_PROC_MPI=${DEFAULT_NUM_PROC_OCE}
+          ATM_PROC_MPI=${DEFAULT_NUM_PROC_ATM}
+          NUM_PROC_CPL=${DEFAULT_NUM_PROC_CPL} # for backward compatibility
+          NUM_PROC_OCE=${DEFAULT_NUM_PROC_OCE} # for backward compatibility
+          NUM_PROC_ATM=${DEFAULT_NUM_PROC_ATM} # for backward compatibility
+          PROCESSUS_NUMBER=${DEFAULT_NUM_PROC_TOTAL}
+        else
+          # with have only one executable
+          echo "We will use ${BATCH_NUM_PROC_TOT} MPI tasks for ${CompNameFirst} : ${config_Executable_Name} "
+          OK_PARA_MPI=true
+          eval ${CompNameFirst}_PROC_MPI=${BATCH_NUM_PROC_TOT}
+          PROCESSUS_NUMBER=${BATCH_NUM_PROC_TOT}
         fi
-
-    else # BATCH_NUM_PROC_TOT=""
-	if ( ${OK_PARA_MPI} ) ; then
-	    echo "You have not given a value of ${BATCH_NUM_PROC_TOT} processors,"
-	    echo "but you have filled the parallel parameter in config->Executable->list."
-	    echo "Please add BATCH_NUM_PROC_TOT variable in job header."
-	    echo "We stop now."
-	    exit 1
-	else
-    	# sequential case !
-	    if [ ${PROCESSUS_NUMBER} -eq 0 ] ; then
-               (( PROCESSUS_NUMBER = 1 ))
-               echo "PROCESSUS_NUMBER is all 0 (sequential use of old definition in config->Executable->list)."
-               echo "We set it to 1."
-    	    fi
-	fi
-    fi
-
-    IGCM_debug_Print 1 "MPI/OMP treatment PROCESSUS_NUMBER = ${PROCESSUS_NUMBER}"
-
-#     if ( ${OK_PARA_MPI} || ${OK_PARA_OMP} || ${OK_PARA_NOD} ) ; then
-    IGCM_sys_build_execution_scripts
-#     fi
-
-    ExecutionFail=false
-
-    IGCM_debug_PopStack "IGCM_config_PeriodStart"
+      else 
+        PROCESSUS_NUMBER=1
+      fi
+    fi
+    # Verification with PBS parameter
+    if [ ${BATCH_NUM_PROC_TOT} -ne ${PROCESSUS_NUMBER} ] ; then
+      echo "Warning with parallelization parameters !"
+      echo "Job header variable BATCH_NUM_PROC_TOT = ${BATCH_NUM_PROC_TOT} "
+      echo "is the total number of _processors_ reserved."
+      echo "It is not equal to the sum of _processus_  = ${PROCESSUS_NUMBER}."
+      echo "We stop now."
+      exit 1
+    fi
+  else # BATCH_NUM_PROC_TOT=""
+    if ( ${OK_PARA_MPI} ) ; then
+      echo "You have not given a value of ${BATCH_NUM_PROC_TOT} processors,"
+      echo "but you have filled the parallel parameter in config->Executable->list."
+      echo "Please add BATCH_NUM_PROC_TOT variable in job header."
+      echo "We stop now."
+      exit 1
+    else
+      # sequential case !
+      if [ ${PROCESSUS_NUMBER} -eq 0 ] ; then
+        (( PROCESSUS_NUMBER = 1 ))
+        echo "PROCESSUS_NUMBER is all 0 (sequential use of old definition in config->Executable->list)."
+        echo "We set it to 1."
+      fi
+    fi
+  fi
+
+  IGCM_debug_Print 1 "MPI/OMP treatment PROCESSUS_NUMBER = ${PROCESSUS_NUMBER}"
+
+  IGCM_sys_build_execution_scripts
+
+  ExecutionFail=false
+
+  IGCM_debug_PopStack "IGCM_config_PeriodStart"
+}
+
+#===================================
+function IGCM_config_SaveSourceModifications
+{
+  IGCM_debug_PushStack "IGCM_config_SaveSourceModifications"
+
+  typeset ExeOutDateMax listVarEnv
+  ExeOutDateMax=$1
+
+  listVarEnv="ExeOutDateMax,R_OUT_EXE,PREFIX,SUBMIT_DIR"
+  IGCM_sys_RshMaster "\
+    . ${libIGCM}/libIGCM_sys/libIGCM_sys.ksh; \
+    export ExeOutDateMax=${ExeOutDateMax};\
+    export R_OUT_EXE=${R_OUT_EXE};\
+    export PREFIX=${PREFIX};\
+    export SUBMIT_DIR=${SUBMIT_DIR};\
+    export listVarEnv=${listVarEnv};\
+    Script_Output=out_SaveSourceModifications;\
+    IGCM_sys_Qsub ${libIGCM}/SaveSourceModifications.job ${ExeOutDateMax} ${R_OUT_EXE} ${PREFIX} ${SUBMIT_DIR}"
+
+  IGCM_debug_PopStack "IGCM_config_SaveSourceModifications"
 }
 
@@ -715,25 +804,26 @@
 function IGCM_config_PeriodEnd
 {
-    IGCM_debug_PushStack "IGCM_config_PeriodEnd"
-
-    echo
-    IGCM_debug_Print 1 "IGCM_config_PeriodEnd"
-    echo
-
-    #==================================#
-    #         Save Job output          #
-    #==================================#
-    IGCM_sys_Put_Out ${Exe_Output} ${R_OUT_KSH}/${PREFIX}_${Exe_Output}
-    eval FileToBeDeleted[${#FileToBeDeleted[@]}]="${Exe_Output}"
-
-    IGCM_card_CheckConflict run.card
-    IGCM_sys_Put_Out ${SUBMIT_DIR}/run.card ${R_OUT_KSH}/run.card rw
-
-if [ ${DRYRUN} -le 1 ] ; then
+  IGCM_debug_PushStack "IGCM_config_PeriodEnd"
+
+  echo
+  IGCM_debug_Print 1 "IGCM_config_PeriodEnd"
+  echo
+
+  #==================================#
+  #         Save Job output          #
+  #==================================#
+  IGCM_sys_PutBuffer_Out ${Exe_Output} ${R_BUF_KSH}/${PREFIX}_${Exe_Output}
+  eval FileToBeDeleted[${#FileToBeDeleted[@]}]="${Exe_Output}"
+
+      IGCM_card_CheckConflict run.card
+      IGCM_sys_PutBuffer_Out ${SUBMIT_DIR}/run.card ${R_BUF_KSH}/run.card rw
+
+
+  if [ ${DRYRUN} -le 1 ] ; then
     IGCM_debug_Print 1 "Check components binary : size and creation date"
 
     typeset LS_comp LS_bin ExeDate ExeCpuLog NextExeSize LastCompExeSize
     typeset comp i    
-    typeset ExeNameIn ExeNameOut 
+    typeset ExeNameIn ExeNameOut UpdateExe ExeSecDateMax
 
     #==================================#
@@ -743,11 +833,11 @@
     (( i=0 ))
     if ( ${FirstInitialize} ) ; then
-	run_Log_LastExeSize=""
-	for comp in ${config_ListOfComponents[*]} ; do
-	    run_Log_LastExeSize[$i]=0
-	    (( i=i+1 ))
-	done
+      run_Log_LastExeSize=""
+      for comp in ${config_ListOfComponents[*]} ; do
+        run_Log_LastExeSize[$i]=0
+       (( i=i+1 ))
+      done
     else
-	IGCM_card_DefineArrayFromOption ${SUBMIT_DIR}/run.card Log LastExeSize
+      IGCM_card_DefineArrayFromOption ${SUBMIT_DIR}/run.card Log LastExeSize
     fi
     #==================================#
